#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	
	ofSetVerticalSync(true);
	
	ofBackground(198,238,237);
	
	ofSetCircleResolution(200);
	
	ofEnableSmoothing();
	
	ofEnableAlphaBlending();
	
	radiuspath = 10;

}

//--------------------------------------------------------------
void testApp::update(){
	
	
	radiuspath = radiuspath + 0.1;

}

//--------------------------------------------------------------
void testApp::draw(){
	
	float xorig1 = ofGetWidth()/2;
	float yorig1 = ofGetHeight()/2;
	
	float xorig2 = ofGetWidth()/4;
	float yorig2 = ofGetWidth()/4;
	
	float xorig3 = 800;
	float yorig3 = ofGetWidth()/4;
	
	float angleR = ofGetElapsedTimef()*3.5;
	float angleR2 = ofGetElapsedTimef()*1.7;
	
	float xR = xorig1 + radiuspath * cos(angleR);
	float yR = yorig1 + radiuspath * -sin(angleR);
	
	float sinOfTime = sin( ofGetElapsedTimef() * 2 );
	float sinOfTimeMapped = ofMap( sinOfTime, -1, 1, 50, 80);
	float sinOfTimeMapped2 = ofMap( sinOfTime, -1, 1, 20, 130);
	float sinOfTimeMapped3 = ofMap( sinOfTime, -1, 1, 70, 100);
	float sinOfTimeMapped4 = ofMap( sinOfTime, -1, 1, 50, 300);
	
	ofSetColor(125, 50);
	
	ofNoFill();
	ofCircle(400,400, sinOfTimeMapped);
	ofCircle(400, 400, sinOfTimeMapped2);
	ofCircle(400, 400, sinOfTimeMapped3);
	ofCircle(400, 400, sinOfTimeMapped4);
	
	ofPoint temp;
	temp.x = xR;
	temp.y = yR;
	points.push_back(temp);
	if (points.size() > 10000){
		points.erase(points.begin());
		
	}

	ofSetColor(89,200,200,70);
	ofCircle(800,100, sinOfTimeMapped);
	ofCircle(800,100, sinOfTimeMapped2);
	ofCircle(700,500, sinOfTimeMapped2);
	ofCircle(700, 500, sinOfTimeMapped2);
	ofCircle(700, 500, sinOfTimeMapped3);
	ofCircle(700, 500, sinOfTimeMapped4);
	
	ofSetColor(89,200,200);
	ofNoFill();
	ofBeginShape();
	for (int i = 0; i < points.size(); i++){
		ofVertex(points[i].x, points[i].y);
	}
	ofEndShape();
	

	
	
	for (int i = 0; i < 20; i++){
	
		float radius = 50 + i * 20;
		
		float angle = ofGetElapsedTimef() * (1 + i / 10.0);
		
		float x = xorig1 + radius * cos(angle);
		float y = yorig1 + radius * -sin(angle);
		
		//ofSetRectMode(OF_RECTMODE_CENTER);
		ofSetColor(255,85);
		ofFill();
		
		ofEllipse(x, y, 100+i++, 100+i++);
	
	}	
	
	for(int i=0; i<10; i++){
		
		float radius2 = 30+i*18;
		float angle2 = ofGetElapsedTimef() * (1+i/5.0);
		
		float x2 = xorig2 + radius2  * cos(angle2);
		float y2 = yorig2 + radius2  * -sin(angle2);
		
		ofSetColor(100,200,200,85);
		ofEllipse(x2, y2, 40, 40);
	}
	
	for(int i=0; i<10; i++){
		
		float radius2 = 30+i*18;
		float angle2 = ofGetElapsedTimef() * (1+i/5.0);
		
		float x3 = xorig3 + radius2  * cos(angle2);
		float y3 = yorig3 + radius2  * -sin(angle2);
		
		ofSetColor(100,200,200,85);
		ofEllipse(x3, y3, 50, 50);
	}
	
	glPushMatrix();
	glTranslatef(ofGetWidth()/2,ofGetHeight()/2,0);
	ofSetColor(255,90);
	ofFill();
	ofSetPolyMode(OF_POLY_WINDING_ODD);
	ofBeginShape();
	float angleStep 	= TWO_PI/(100.0f + sin(ofGetElapsedTimef()/5.0f) * 60); 
	float radiusAdder 	= 1.5f;
	float radius 		= 10;
	for (int i = 0; i < 200; i++){
		float anglef = (i) * angleStep;
		float x = radius * cos(anglef);
		float y = radius * sin(anglef); 
		ofVertex(x,y);
		radius 	+= radiusAdder; 
	}
	ofEndShape(OF_CLOSE);
	
	glPopMatrix();

	glPushMatrix();
	glTranslatef(ofGetWidth()/2,ofGetHeight()/2,0);
	ofSetColor(100,200,200,50);
	ofFill();
	ofSetPolyMode(OF_POLY_WINDING_ODD);
	ofBeginShape();
	float angleStep2 	= TWO_PI/(100.0f + sin(ofGetElapsedTimef()/5.0f) * 60); 
	float radiusAdder2 	= 2.3f;
	float radius2 		= 10;
	for (int i = 0; i < 200; i++){
		float anglef2 = (i) * angleStep2;
		float x2 = radius2 * cos(anglef2);
		float y2 = radius2 * sin(anglef2); 
		ofVertex(x2,y2);
		radius2 	+= radiusAdder2; 
	}
	ofEndShape(OF_CLOSE);
	glPopMatrix();

}

//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

